package main

import (
	db "netina/database"
	i "netina/initialize"
	"netina/router"

	"github.com/labstack/echo/v4"
	"github.com/labstack/echo/v4/middleware"
)




func main(){
	db.Create_tables()
	e := echo.New()
	e.Use(middleware.Logger())
	e.Use(middleware.Recover())
	i.Init()
	router.LoginRoutes(e)
	router.UploadFile(e)
	router.OwnerRoutes(e)
	router.LicenseRoutes(e)
	router.PlanRoutes(e)
	router.StoreRoutes(e)
	router.UserRoutes(e)
	router.RoleRoutes(e)
	router.PanelRoutes(e)
	e.Logger.Fatal(e.Start(":8800"))
}	