package owner_repository

import (
	"netina/models"

	"gorm.io/gorm"
)

type OwnerQuery interface {
	GetOwner(id uint) (*models.Owner, error)
}



type OwnerQueryRepository struct{
	DB *gorm.DB
}



func (r *OwnerQueryRepository) GetOwner(id uint)(*models.Owner , error){
	var owner models.Owner 
	if err := r.DB.Where("is_removed = ?" , false).Where("owner_id = ?" , id).First(&owner).Error; err != nil {
		return nil , err
	}

	return &owner , nil
}