package store_repository

import (
	"netina/models"

	"gorm.io/gorm"
)

type StoreQuery interface{
	GetStore(id uint)(*models.Store , error)
	GetStores(id uint)([]models.Store , error)
}

type StoreQueryRepository struct{
	DB *gorm.DB
}


func (r *StoreQueryRepository) GetStore(id uint)(*models.Store , error){
	var store models.Store 
	if err := r.DB.Where("is_removed = ?" , false).Where("store_id = ?" , id).First(&store).Error; err != nil {
		return nil , err
	}

	return &store , nil
}

func (r *StoreQueryRepository) GetStores(id uint)([]models.Store , error){
	var store []models.Store 
	if err := r.DB.Where("is_removed = ?" , false).Where("owner_id = ?" , id).Find(&store).Error; err != nil {
		return nil , err
	}

	return store , nil
}

