package authentication

import "netina/models"

func GenerateTokenForUser(userID uint) (string, error) {
	claims, err := GenerateClaims(userID)
	if err != nil {
		return "", err
	}
	token, err := GenerateJWT(claims)
	if err != nil {
		return "", err
	}
	return token, nil
}

func ValidateUserToken(tokenString string) (*models.JWTClaims, error) {
	claims, err := ValidateJWT(tokenString)
	if err != nil {
		return nil, err
	}
	return claims, nil
}
